/********* MupColleaguePlugin.m Cordova Plugin Implementation *******/

#import <Cordova/CDV.h>
#import <ColleagueCircle/YGFriendsCircleVC.h>
#import <LoginServiceKit/LoginServiceKit.h>
#import <AddtionsKit/AddtionsKit.h>

@interface MupColleaguePlugin : CDVPlugin {
  // Member variables go here.
}

- (void)init:(CDVInvokedUrlCommand*)command;
- (void)open:(CDVInvokedUrlCommand*)command;

@end

@implementation MupColleaguePlugin

/**
 * 初始化同事圈
 * @param command - initParams 初始化信息 server、imgServer、wsServer、mupId、cookie;
 * @param command - userInfo 用户信息
 */
- (void)init:(CDVInvokedUrlCommand*)command {
    NSString *myarg = command.arguments.firstObject;

    if (myarg != nil) {
        NSDictionary *dict = [NSDictionary initWithJsonString:myarg];

        // 服务器地址
        MessageServiceServerHost = [[NSMutableString alloc] initWithString:dict[@"imgServer"]];
        WebsocketServerHost = [[NSMutableString alloc] initWithString:dict[@"wsServer"]];
        MUPServiceServerHost = [[NSMutableString alloc] initWithString:dict[@"server"]];

        // 应用Id
        [YGGlobalVariable sharedInstance].appId = dict[@"mupId"];
    }

    // init userinfo
    NSString *userinfo = [command argumentAtIndex:1];
    if (userinfo) {
        NSDictionary *dict = [NSDictionary initWithJsonString:userinfo];
        [YGUserInfoModel saveWithData:dict];
    }

    CDVPluginResult *pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:@"colleague init finished"];

    [self.commandDelegate sendPluginResult:pluginResult callbackId:command.callbackId];
}

/**
 打开圈主页

 @param command command description
 */
- (void)open:(CDVInvokedUrlCommand *)command {

    YGFriendsCircleVC *vc = [[YGFriendsCircleVC alloc] init];
    vc.getDataType = GetDataTypePersonShare;
    vc.title = @"同事圈";
    vc.hidesBottomBarWhenPushed = YES;
    if (self.viewController.navigationController) {
        [self.viewController.navigationController pushViewController:vc animated:YES];
    } else {
        UINavigationController *navgationController = [[UINavigationController alloc] initWithRootViewController:vc];
        [self.viewController presentViewController:navgationController animated:YES completion:nil];
    }

    CDVPluginResult *pluginResult = [CDVPluginResult resultWithStatus:CDVCommandStatus_OK messageAsString:@"open colleague circle finished!"];
    [self.commandDelegate sendPluginResult:pluginResult callbackId:command.callbackId];
}

@end
