var fs = require('fs');
var path = require('path');
var rootdir = process.argv[2];

const TAG = "colleague"
console.log(TAG + " rootdir " + rootdir)

if (rootdir && process.argv[4].toLowerCase().indexOf(TAG) !== -1) {

    //替换build.gradle文件内容
    try {
        //
        var resGradlePath = path.join(rootdir, '../platforms/android/build.gradle');
        if (fs.existsSync(resGradlePath)) {
            replace_string_in_file(resGradlePath, "res.srcDirs = ['res']", "res.srcDir 'res'");
        } else {
            console.log(TAG + " missing: " + resGradlePath);
        }
    } catch (e) {
        console.log(e)
    }

    //MultiDex Change
    try {
        var manifestPath = path.join(rootdir, '../platforms/android/AndroidManifest.xml');
        //判断AndroidManifest.xml文件是否存在
        if (fs.existsSync(manifestPath)) {
            var data2 = fs.readFileSync(manifestPath, 'utf8');
            if (data2.indexOf("multidex") === -1) {
                replace_string_in_file(manifestPath, "<application", '<application android:name="android.support.multidex.MultiDexApplication"  android:theme="@style/Theme.AppCompat.Light.NoActionBar"');
            } else {
                console.log(TAG + "manifest multidex application had init ");
            }
        } else {
            console.log(TAG + " missing: " + manifestPath);
        }
        //替换build.gradle文件支持MultiDex
        var gradlePath = path.join(rootdir, '../platforms/android/build.gradle');
        if (fs.existsSync(gradlePath)) {
            var data = fs.readFileSync(gradlePath, 'utf8');
            if (data.indexOf(" multidex") === -1) {
                replace_string_in_file(gradlePath, /defaultConfig\s*\{/gi, 'defaultConfig {\n multiDexEnabled true');
                replace_string_in_file(gradlePath, /}\s*dependencies\s*\{/gi, '}\n dependencies {\n compile "com.android.support:multidex:1.0.0"');
            } else {
                console.log(TAG + " multidex had init ");
            }
        } else {
            console.log(TAG + " missing: " + gradlePath);
        }

    } catch (e) {
        console.log(e)
    }


    createConfig();

    function createConfig() {
        try {
            var configDir = path.join(rootdir, '../config');

            if (fs.existsSync(configDir)) {
                console.log(TAG + " configDir dirs exits")
            } else {
                fs.mkdirSync(configDir)
                console.log(TAG + " configDir dirs create")
            }

            var litePalPath = path.join(configDir, '/litepal.xml');
            var litePalSource = path.join(rootdir, '../plugins/cordova-plugin-colleague/src/android/xml/litepal.xml');
            copyIfNotExist(litePalSource, litePalPath, "litepal.xml")


            var fullDbPath = path.join(configDir, '/locations.db');
            var sourceDb = path.join(rootdir, '../plugins/cordova-plugin-colleague/src/android/db/locations.db');
            copyIfNotExist(sourceDb, fullDbPath, "locations.db")


            var fullExPath = path.join(configDir, '/expression_config.xml');
            var sourceEx = path.join(rootdir, '../plugins/cordova-plugin-colleague/src/android/xml/expression_config.xml');
            copyIfNotExist(sourceEx, fullExPath, "expression_config.xml")


            var fullConfigPath = path.join(configDir, '/config.xml');
            var sourceConfig = path.join(rootdir, '../plugins/cordova-plugin-colleague/src/android/xml/config.xml');
            copyIfNotExist(sourceConfig, fullConfigPath, "config.xml")


            var sourceProvider = path.join(rootdir, '../plugins/cordova-plugin-colleague/src/android/xml/provider_file.xml');
            var targetProviderPath = path.join(configDir, '/provider_file.xml');
            copyIfNotExist(sourceProvider, targetProviderPath, "provider_file.xml")


        } catch (e) {
            console.log(e)
        }
    }

    function copyIfNotExist(sourcePath, targetPath, consoleTag) {
        console.log(TAG + " " +consoleTag + " source path " + sourcePath)
        console.log(TAG + " " +consoleTag + " target path " + targetPath)
        if (fs.existsSync(targetPath)) {
            console.log(TAG + " " +consoleTag + " target exits")
        } else {
            copy(sourcePath, targetPath)
            console.log(TAG + " " +consoleTag + "target copy")
        }
    }

    function copy(src, dst) {
        fs.writeFileSync(dst, fs.readFileSync(src));
    }

    //正则表达式替换文本
    function replace_string_in_file(filename, to_replace, replace_with) {
        var data = fs.readFileSync(filename, 'utf8');
        console.log(to_replace)
        console.log(replace_with)
        var result = data.replace(to_replace, replace_with);
        fs.writeFileSync(filename, result, 'utf8');
    }
}

