var fs = require('fs');
var path = require('path');
var rootdir = process.argv[2];

const TAG = "colleague "

console.log(TAG + " rootdir " + rootdir)

if (rootdir) {

    moveConfig();

    function moveConfig() {
        try {
            //数据库文件
            var litePalSource = path.join(rootdir, '../config/litepal.xml');
            var litePalTarget = path.join(rootdir, '../platforms/android/assets/litepal.xml');
            compareCopy(litePalSource, litePalTarget, null, "litepal.xml")

            //android外部权限读取文件
            var providerSource = path.join(rootdir, '../config/provider_file.xml');
            var providerTarget = path.join(rootdir, '../platforms/android/res/xml/provider_file.xml');
            compareCopy(providerSource, providerTarget, null, "provider_file.xml")

            //数据库配置文件
            var sourceDB = path.join(rootdir, '../config/locations.db');
            var targetDBPath = path.join(rootdir, '../platforms/android/assets/db/locations.db');
            var targetDBPathDir = path.join(rootdir, '../platforms/android/assets/db');
            compareCopy(sourceDB, targetDBPath, targetDBPathDir, "locations.db")

            //表情配置文件
            var sourceEx = path.join(rootdir, '../config/expression_config.xml');
            var fullExPath = path.join(rootdir, '../platforms/android/res/raw/expression_config.xml');
            var fullExPathDir = path.join(rootdir, '../platforms/android/res/raw');
            compareCopy(sourceEx, fullExPath, fullExPathDir, "expression_config.xml")

            //网络配置文件
            var fullConfigPath = path.join(rootdir, '../platforms/android/res/raw/config.xml');
            var fullConfigPathDir = path.join(rootdir, '../platforms/android/res/raw');
            var sourceConfig = path.join(rootdir, '../config/config.xml');
            compareCopy(sourceConfig, fullConfigPath, fullConfigPathDir, "config.xml")


        } catch (e) {
            console.log(e)
        }
    }

    function compareCopy(sourcePath, targetPath, targetDirNeedMk, consoleTag) {
        console.log(TAG + consoleTag +" source path " + sourcePath)
        console.log(TAG + consoleTag +" target path " + targetPath)
        if (fs.existsSync(targetPath)) {
            console.log(TAG + consoleTag + " target exits")
            if (!compareFile(sourcePath, targetPath)) {
                fs.unlinkSync(targetPath);
                console.log(TAG + consoleTag + " changed copy")
                copy(sourcePath, targetPath)
            }
        } else {
            if (targetDirNeedMk != null && !fs.existsSync(targetDirNeedMk)) {
                fs.mkdirSync(targetDirNeedMk)
            }
            copy(sourcePath, targetPath)
            console.log(TAG + consoleTag + "  not exist copy")
        }
    }


    function copy(src, dst) {
        fs.writeFileSync(dst, fs.readFileSync(src));
    }

    //正则表达式替换文本
    function compareFile(source, target) {
        var sourceData = fs.readFileSync(source, 'utf8');
        var targetData = fs.readFileSync(target, 'utf8');
        if (sourceData == targetData) {
            console.log("compareFile not change")
            return true
        }
        console.log("compareFile changed")
        return false
    }
}

